unit RegEdit;

{ Save 20Ko in your applications with RegEdit in place of Registry ! }
{ By Paul TOTH <tothpaul@free.fr> }
{ http://tothpaul.free.fr }

interface

Uses
 Windows;

Function WriteRegString(Key:HKEY;Path:string;Value,Data:string):boolean;
Function WriteRegStrings(Key:HKEY;Path:string;Values:array of string):boolean;
Function ReadRegString(Key:HKEY;Path:string;Value,Default:string):string;
Function DeleteRegString(Key:HKEY;Path:string;Value:string):boolean;

implementation

Function WriteRegString(Key:HKEY;Path:string;Value,Data:string):boolean;
 Var
  Handle:HKEY;
  Disposition:integer;
 begin
  Result:=(RegCreateKeyEx(Key,pchar(Path),0,nil,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,nil,Handle,@Disposition)=ERROR_SUCCESS);
  if Result then begin
   Result:=(RegSetValueEx(Handle,pchar(Value),0,REG_SZ,pchar(Data),Length(Data))=ERROR_SUCCESS);
   RegCloseKey(Handle);
  end;
 end;

Function WriteRegStrings(Key:HKEY;Path:string;Values:array of string):boolean;
 Var
  Handle:HKEY;
  Disposition:integer;
  i:integer;
  Value,Data:string;
  p:integer;
 begin
  Result:=(RegCreateKeyEx(Key,pchar(Path),0,nil,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,nil,Handle,@Disposition)=ERROR_SUCCESS);
  if Result then begin
   for i:=Low(Values) to High(Values) do begin
    Value:=Values[i];
    p:=pos('=',Value);
    Data:=Copy(Value,p+1,Length(Value));
    SetLength(Value,p-1);
    Result:=Result and (RegSetValueEx(Handle,pchar(Value),0,REG_SZ,pchar(Data),Length(Data))=ERROR_SUCCESS);
   end;
   RegCloseKey(Handle);
  end;
 end;

Function ReadRegString(Key:HKEY;Path:string;Value,Default:string):string;
 Var
  Handle:HKEY;
  RegType:integer;
  DataSize:integer;
 begin
  Result:=Default;
  if (RegOpenKeyEx(Key,pchar(Path),0,KEY_ALL_ACCESS,Handle)=ERROR_SUCCESS) then begin
   if RegQueryValueEx(Handle,pchar(Value),nil,@RegType,nil,@DataSize)=ERROR_SUCCESS then begin
    SetLength(Result,Datasize);
    RegQueryValueEx(Handle,pchar(Value),nil,@RegType,PByte(pchar(Result)),@DataSize);
    SetLength(Result,Datasize-1);
   end;
   RegCloseKey(Handle);
  end;
 end;

Function DeleteRegString(Key:HKEY;Path:string;Value:string):boolean;
 Var
  Handle:HKEY;
 begin
  Result:=(RegOpenKeyEx(Key,pchar(Path),0,KEY_ALL_ACCESS,Handle)=ERROR_SUCCESS);
  if Result then begin
   Result:=(RegDeleteValue(Handle,pchar(Value))=ERROr_SUCCESS);
   RegCloseKey(Handle);
  end;
 end;

end.
